/*
 * Addition.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

public class Addition extends JFrame 
{
	static JTextField problemTextField = new JTextField();
	static JTextField answerTextField = new JTextField();
	static JLabel messageLabel = new JLabel();
	static JLabel scoreLabel = new JLabel();
	static JButton nextButton = new JButton();
	static JButton exitButton = new JButton();

	static Random myRandom = new Random();
  static int sum;
  static int numProb, numRight;

  public static void main(String args[]) 
  {
  	//construct frame
    new Addition().show();
  }

  public Addition() 
  {
  	// code to build the form
    setTitle("Addition");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    problemTextField.setText("");
    problemTextField.setColumns(10);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(problemTextField, gridConstraints);
    answerTextField.setText("");
    answerTextField.setColumns(5);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    getContentPane().add(answerTextField, gridConstraints);
    answerTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		answerTextFieldActionPerformed(e);
    	}
    });
    messageLabel.setText("");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(messageLabel, gridConstraints);
    scoreLabel.setText("Score: 0");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(scoreLabel, gridConstraints);
    nextButton.setText("Next");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    getContentPane().add(nextButton, gridConstraints);
    nextButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		nextButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 2;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    pack();
    numProb = 0;
    numRight = 0;
    nextButton.doClick();

	}
	
  private void answerTextFieldActionPerformed(ActionEvent e)
  {
  	int ans;
  	// check to make sure valid integer input
  	if (!validateIntegerNumber(answerTextField))
  	{
  		return;
  	}
  	// check answer
    ans = Integer.valueOf(answerTextField.getText()).intValue();
    if (ans == sum)
    {
    	numRight++;
      messageLabel.setText("That's correct!");
    }
    else
    {
      messageLabel.setText("Answer is " + String.valueOf(sum));
    }
    scoreLabel.setText("Score: " + String.valueOf((int) (100 * numRight / numProb)));
    nextButton.setEnabled(true);
    nextButton.requestFocus();
  }
  
	private void nextButtonActionPerformed(ActionEvent e)
	{
		// Generate next addition problem
    int number1, number2;
    answerTextField.setText("");
    messageLabel.setText("");
    numProb++;
    // Generate random numbers for addends
    number1 = myRandom.nextInt(20);
    number2 = myRandom.nextInt(20);
    problemTextField.setText(String.valueOf(number1) + " + " + String.valueOf(number2) + " = ");
    // Find sum
    sum = number1 + number2;
    nextButton.setEnabled(false);
    answerTextField.requestFocus();

	}

	private void exitButtonActionPerformed(ActionEvent e)
	{
  	System.exit(0);
	}

  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }

	public boolean validateIntegerNumber(JTextField tf)
	{
		// checks to see if text field contains
		// valid integer number with only digits or negative sign
		String s = tf.getText().trim();
		boolean valid = true;
		if (s.length() == 0)
		{
			valid = false;
		}
		else
		{
			for (int i = 0; i < s.length(); i++)
			{
				char c = s.charAt(i);
				if ((c >= '0' && c <= '9') || (c == '-' && i == 0))
				{
					continue;
				}
				else
				{
					// invalid character found
					valid = false;
				}
			}
		}
		if (valid)
		{
			tf.setText(s);
		}
		else
		{
			tf.setText("");
			tf.requestFocus();
		}
		return (valid);
	}
	

}
